/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.ship.device.wrapper;

import org.springblade.common.cache.UserCache;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.system.entity.User;
import org.springblade.ship.device.entity.Device;
import org.springblade.ship.device.vo.DeviceVO;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-11-15
 */
public class DeviceWrapper extends BaseEntityWrapper<Device, DeviceVO>  {

	public static DeviceWrapper build() {
		return new DeviceWrapper();
 	}

	@Override
	public DeviceVO entityVO(Device device) {
		DeviceVO deviceVO = Objects.requireNonNull(BeanUtil.copy(device, DeviceVO.class));

		if (device.getPersonIds() != null){
			List<String> nameList = new ArrayList<>();
			if (StringUtil.isNotBlank(device.getPersonIds())){
				String[] split = device.getPersonIds().split(",");
				for (int i = 0; i < split.length; i++) {
					String userId = split[i];
					User user = UserCache.getUser(Long.valueOf(userId));
					nameList.add(user.getName());
				}
				deviceVO.setPersonNames(StringUtil.join(nameList));
			}
		}

		//User updateUser = UserCache.getUser(device.getUpdateUser());
		//deviceVO.setUpdateUserName(updateUser.getName());

		return deviceVO;
	}

}
